#include<bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define int long long

void solve() {
    string s1, s2;
    cin >> s1 >> s2;
    std::reverse(s1.begin(), s1.end());
    std::reverse(s2.begin(), s2.end());
    while (s1.size() < s2.size()) {
        s1.push_back(0);
    }
    while (s2.size() < s1.size()) {
        s2.push_back(0);
    }
    int n = (int) s1.size();
    string s;
    for (int i = 0; i < n; ++i) {
        s.push_back(max(s1[i], s2[i]));
    }
    while ((int) s.size() > 1 && s.back() == '0') {
        s.pop_back();
    }
    std::reverse(s.begin(), s.end());
    cout << s << ' ';
    s.clear();
    s.resize(2 * n - 1, '0');
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            s[i + j] = max(s[i + j], min(s1[i], s2[j]));
        }
    }
    while ((int) s.size() > 1 && s.back() == '0') {
        s.pop_back();
    }
    std::reverse(s.begin(), s.end());
    cout << s;
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
