#include<bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define int long long
const ld pi = acosl(-1), inf = 1e18;
int n;
ld dp[1 << 12][12];
vector<pair<ld, ld>> a;

struct vec {
    ld x = 0, y = 0;

    vec operator-(vec oth) {
        return {x - oth.x, y - oth.y};
    }

    ld operator*(vec oth) {
        return x * oth.x + y * oth.y;
    }

    ld operator%(vec oth) {
        return x * oth.y - y * oth.x;
    }

    ld len() {
        return sqrtl(x * x + y * y);
    }
};

ld dist(int i, int j, ld p) {
    vec f(a[i].first - a[j].first, a[i].second - a[j].second);
    vec f1(cosl(p), sinl(p));
    ld s = atan2l(f1 % f, f1 * f);
    while (s < 0) {
        s += pi / 2;
    }
    while (s > pi / 2) {
        s -= pi / 2;
    }
    return f.len() * (sinl(s) + sinl(pi / 2 + s));
}

ld fun(ld p) {
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            dp[mask][i] = inf;
        }
    }
    for (int i = 0; i < n; ++i) {
        dp[1 << i][i] = 0;
    }
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                int mask1 = mask ^ (1 << i);
                for (int j = 0; j < n; ++j) {
                    if ((mask1 >> j) & 1) {
                        dp[mask][i] = min(dp[mask][i], dp[mask1][j] + dist(i, j, p));
                    }
                }
            }
        }
    }
    ld ans = inf;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[(1 << n) - 1][i]);
    }
    return ans;
}

void solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    ld ans = inf;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            vec f(a[i].first - a[j].first, a[i].second - a[j].second);
            vec f1(1, 0);
            ld s = atan2l(f1 % f, f1 * f);
            while (s < 0) {
                s += pi / 2;
            }
            while (s > pi / 2) {
                s -= pi / 2;
            }
            ans = min(ans, fun(s));
        }
    }
    cout << ans;
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
