#include<bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define int long long
const int N = 2e5;
int h[N], d[N];
vector<int> g[N];

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        if (q != w) {
            g[q].emplace_back(w);
            g[w].emplace_back(q);
        }
    }
    for (int i = 0; i < n; ++i) {
        d[i] = -1;
    }
    for (int i = 0; i < k; ++i) {
        int p, f;
        cin >> p >> f;
        --p;
        if (h[p] < f) {
            h[p] = f;
            d[p] = f;
        }
    }
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        st.insert({h[i], i});
    }
    while (!st.empty()) {
        auto [D, v] = *(--st.end());
        if (D == -1) {
            break;
        }
        st.erase({D, v});
        for (auto to : g[v]) {
            if (d[to] < D - 1) {
                st.erase({d[to], to});
                d[to] = D - 1;
                st.insert({d[to], to});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (d[i] != -1) {
            ans.emplace_back(i + 1);
        }
    }
    cout << (int) ans.size() << '\n';
    for (auto it : ans) {
        cout << it << ' ';
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
